package cn.fw.dalaran.dao;

import cn.fw.dalaran.domain.db.VideoPool;
import cn.fw.dalaran.domain.dto.PoolQueryDTO;
import cn.fw.dalaran.domain.vo.VideoPoolVO;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.time.LocalDate;
import java.util.List;

/**
 * @author kurisu
 * @date 2021-11-17 14:33
 * @description 短视频池
 */
@Repository
public interface VideoPoolDao extends BaseMapper<VideoPool> {
    /**
     * 根据账号删除对应日期数据
     * @param accountId
     * @param date
     */
    void deleteByAccountDate(@Param("accountId") Long accountId, @Param("date") LocalDate date);

    /**
     * 查询短视频池列表
     *
     * @param startIndex
     * @param pageSize
     * @param queryDTO
     * @return
     */
    List<VideoPoolVO> videoList(@Param("startIndex") Integer startIndex, @Param("pageSize") Integer pageSize, @Param("condition") PoolQueryDTO queryDTO);

    /**
     * 查询短视频数
     *
     * @param queryDTO
     * @return
     */
    Long videoCount(@Param("condition") PoolQueryDTO queryDTO);
}
