package cn.fw.dalaran.domain.db.config;

import cn.fw.dalaran.domain.vo.ValidConfigVo;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author wmy3969
 * @version 1.0
 * @date 2022/1/8 16:56
 * @Description 有效视频/直播判断指标配置
 */
@Data
@Deprecated
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
public class ValidConfig {
    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     * 集团id
     */
    private Long groupId;
    /**
     * 活动主题话题过滤是否有效
     */
    private Integer themeTagEffect;
    /*视频独有参数*/
    /**
     * 点赞数最低标准
     */
    private Integer likeCntVideo;
    private Integer likeCntEffectVideo;
    /**
     * 评论数最低标准
     */
    private Integer commentCntVideo;
    private Integer commentCntEffectVideo;
    /**
     * 分享数最低标准
     */
    private Integer shareCntVideo;
    private Integer shareCntEffectVideo;
    /**
     * 增粉数最低标准
     */
    private Integer newFansCntVideo;
    private Integer newFansCntEffectVideo;
    /**
     * 播放数最低标准
     */
    private Integer playCnt;
    private Integer playCntEffect;
    /**
     * 完整播放量最低标准
     */
    private Integer fullPlayCnt;
    private Integer fullPlayCntEffect;

    /*直播独有参数*/
    /**
     * 点赞数最低标准
     */
    private Integer likeCntLive;
    private Integer likeCntEffectLive;
    /**
     * 评论数最低标准
     */
    private Integer commentCntLive;
    private Integer commentCntEffectLive;
    /**
     * 分享数最低标准
     */
    private Integer shareCntLive;
    private Integer shareCntEffectLive;
    /**
     * 增粉数最低标准
     */
    private Integer newFansCntLive;
    private Integer newFansCntEffectLive;
    /**
     * 观看人数最低标准
     */
    private Integer watchUser;
    private Integer watchUserEffect;
    /**
     * 在线峰值人数最低标准
     */
    private Integer watchUserPeak;
    private Integer watchUserPeakEffect;
    /**
     * 直播时长最低标准
     */
    private Integer duration;
    private Integer durationEffect;

    /**
     * db->vo
     *
     * @param db
     * @return 将DB传参转换成视图
     */
    public static ValidConfigVo toVO(ValidConfig db) {
        final ValidConfigVo vo = new ValidConfigVo();
        vo.setId(db.getId());
        vo.setGroupId(db.getGroupId());
        vo.setThemeTagEffect(db.getThemeTagEffect());
        // 视频独有参数
        vo.setLikeCntVideo(ConfigBean.builder()
                .indexMin(db.getLikeCntVideo())
                .effect(db.getLikeCntEffectVideo())
                .build());
        vo.setCommentCntVideo(ConfigBean.builder()
                .indexMin(db.getCommentCntVideo())
                .effect(db.getCommentCntEffectVideo())
                .build());
        vo.setShareCntVideo(ConfigBean.builder()
                .indexMin(db.getShareCntVideo())
                .effect(db.getShareCntEffectVideo())
                .build());
        vo.setNewFansCntVideo(ConfigBean.builder()
                .indexMin(db.getNewFansCntVideo())
                .effect(db.getNewFansCntEffectVideo())
                .build());
        vo.setPlayCnt(ConfigBean.builder()
                .indexMin(db.getPlayCnt())
                .effect(db.getPlayCntEffect())
                .build());
        vo.setFullPlayCnt(ConfigBean.builder()
                .indexMin(db.getFullPlayCnt())
                .effect(db.getFullPlayCntEffect())
                .build());
        // 直播独有参数
        vo.setLikeCntLive(ConfigBean.builder()
                .indexMin(db.getLikeCntLive())
                .effect(db.getLikeCntEffectLive())
                .build());
        vo.setCommentCntLive(ConfigBean.builder()
                .indexMin(db.getCommentCntLive())
                .effect(db.getCommentCntEffectLive())
                .build());
        vo.setShareCntLive(ConfigBean.builder()
                .indexMin(db.getShareCntLive())
                .effect(db.getShareCntEffectLive())
                .build());
        vo.setNewFansCntLive(ConfigBean.builder()
                .indexMin(db.getNewFansCntLive())
                .effect(db.getNewFansCntEffectLive())
                .build());
        vo.setWatchUser(ConfigBean.builder()
                .indexMin(db.getWatchUser())
                .effect(db.getWatchUserEffect())
                .build());
        vo.setWatchUserPeak(ConfigBean.builder()
                .indexMin(db.getWatchUserPeak())
                .effect(db.getWatchUserPeakEffect())
                .build());
        vo.setDuration(ConfigBean.builder()
                .indexMin(db.getDuration())
                .effect(db.getDurationEffect())
                .build());
        return vo;
    }
}
