package cn.fw.dalaran.domain.enums;

import com.baomidou.mybatisplus.core.enums.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;

/**
 * @author wmy3969
 * @version 1.0
 * @date 2022/2/15 10:56
 * @Description 视频有效性指标配置
 */
public enum ValidVideoEnum implements IEnum<Integer> {
    /**
     * 单次活动有效视频数
     */
    VIDEO_CNT(0,"单次活动有效视频数"),
    /**
     * 播放量
     */
    PLAY_CNT(1, "播放量"),
    /**
     * 完整播放量
     */
    FULL_PLAY_CNT(2, "完整播放量"),
    /**
     * 点赞数
     */
    LIKE_CNT(3, "点赞数"),
    /**
     * 评论数
     */
    COMMENT_CNT(4, "评论数"),
    /**
     * 分享数
     */
    SHARE_CNT(5, "分享数"),
    /**
     * 增粉数
     */
    NEW_FANS_CNT(6, "增粉数"),
    ;

    /**
     * 值
     */
    private final Integer value;
    /**
     * 名称
     */
    @Getter
    private final String name;

    ValidVideoEnum(final Integer value, final String name) {
        this.value = value;
        this.name = name;
    }

    /**
     * 根据枚举值获取枚举对象
     */
    @JsonCreator
    public static ValidVideoEnum ofValue(final Integer value) {
        for (final ValidVideoEnum typeEnum : ValidVideoEnum.values()) {
            if (typeEnum.value.equals(value)) {
                return typeEnum;
            }
        }
        return null;
    }

    /**
     * 获取值
     *
     * @return 值
     */
    @JsonValue
    @Override
    public Integer getValue() {
        return value;
    }

    /**
     * 获取描述
     *
     * @return 值
     */
    @JsonCreator
    public static String getNameByVale(final Integer value) {
        for (final ValidVideoEnum typeEnum : ValidVideoEnum.values()) {
            if (typeEnum.value.equals(value)) {
                return typeEnum.getName();
            }
        }
        return "";
    }

}
