package cn.fw.dalaran.domain.vo;

import cn.fw.common.page.AppPage;
import cn.fw.common.page.PageQuery;

import java.util.Collections;

/**
 * @author kurisu
 * @date 2020-11-20 17:12
 * @description 分页器
 */
public class AppPageVO<T> extends AppPage<T> {

    public static <T> AppPageVO<T> init(PageQuery param) {
        return init(param.getCurrent(), param.getPageSize());
    }

    public static <T> AppPageVO<T> init(int current, int pageSize) {
        AppPageVO<T> appPageVO = new AppPageVO<>();
        appPageVO.setCurrent(current);
        appPageVO.setPageSize(pageSize);
        appPageVO.setData(Collections.emptyList());
        return appPageVO;
    }

    public AppPageVO() {
    }
}
