package cn.fw.dalaran.domain.vo;

import cn.fw.dalaran.domain.db.ThemeFile;
import cn.fw.dalaran.domain.enums.FileTypeEnum;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author wmy3969
 * @version 1.0
 * @date 2022-5-5 10:32:20
 * @Description 文件信息封装
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder(toBuilder = true)
public class FileDesc {
    /**
     * 主键id
     */
    private Long id;
    /**
     * 文件路径信息
     */
    private String fid;
    /**
     * 文件名
     */
    private String fileName;
    /**
     * 文件类型
     */
    private Integer fileType;
    /**
     * 文件归属类型
     */
    private Integer type;

    /**
     * vo->db
     */
    public static ThemeFile toDB(Long themeId, FileDesc vo) {
        return ThemeFile.builder()
                .id(vo.getId())
                .type(FileTypeEnum.THEME_COVER.getValue())
                .fileId(vo.getFid())
                .fileType(vo.getFileType())
                .fileName(vo.getFileName())
                .themeId(themeId)
                .build();
    }
}
